 -------------------------------------------------------------------------------
--
-- Title       : Filter_Procedure
-- Design      : filtr_obrazu
-- Author      : Pawe Sokoowski
-- Company     : AGH
--
-------------------------------------------------------------------------------
--
-- Description : This module includes filter component
--
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

-------------------------------------------------------------------------------

entity Filter_Procedure is 
	port(
		CLK 	  : in  std_logic;
		EN		  : in  std_logic;
		P_11 	  : in  std_logic_vector(7 downto 0);
		P_12 	  : in  std_logic_vector(7 downto 0);
		P_13 	  : in  std_logic_vector(7 downto 0);
		P_21 	  : in  std_logic_vector(7 downto 0);
		P_22 	  : in  std_logic_vector(7 downto 0);
		P_23 	  : in  std_logic_vector(7 downto 0);
		P_31 	  : in  std_logic_vector(7 downto 0);
		P_32 	  : in  std_logic_vector(7 downto 0);
		P_33 	  : in  std_logic_vector(7 downto 0);
		PIXEL_OUT : out std_logic_vector(7 downto 0)
		);
end Filter_Procedure;

-------------------------------------------------------------------------------

architecture Filter_Procedure_Arch of Filter_Procedure is
	
	---- Component declarations -----
	
--	component Average_Filter 
--		port(
--			CLK 	  : in  std_logic;
--			EN		  : in  std_logic;
--			P_11 	  : in  std_logic_vector(7 downto 0);
--			P_12 	  : in  std_logic_vector(7 downto 0);
--			P_13 	  : in  std_logic_vector(7 downto 0);
--			P_21 	  : in  std_logic_vector(7 downto 0);
--			P_22 	  : in  std_logic_vector(7 downto 0);
--			P_23 	  : in  std_logic_vector(7 downto 0);
--			P_31 	  : in  std_logic_vector(7 downto 0);
--			P_32 	  : in  std_logic_vector(7 downto 0);
--			P_33 	  : in  std_logic_vector(7 downto 0);
--			PIXEL_OUT : out std_logic_vector(7 downto 0)
--			);
--	end component Average_Filter; 


component High_Boost_Filter 
	port(
		CLK 	  : in  std_logic;
		EN		  : in  std_logic;
		P_11 	  : in  std_logic_vector(7 downto 0);
		P_12 	  : in  std_logic_vector(7 downto 0);
		P_13 	  : in  std_logic_vector(7 downto 0);
		P_21 	  : in  std_logic_vector(7 downto 0);
		P_22 	  : in  std_logic_vector(7 downto 0);
		P_23 	  : in  std_logic_vector(7 downto 0);
		P_31 	  : in  std_logic_vector(7 downto 0);
		P_32 	  : in  std_logic_vector(7 downto 0);
		P_33 	  : in  std_logic_vector(7 downto 0);
		PIXEL_OUT : out std_logic_vector(7 downto 0)
		);
end component High_Boost_Filter;
	---------------------------------------------------------------------------
begin
	---------------------------------------------------------------------------
	
	----  Component instantiations  ----
	
--	U1: Average_Filter 
		U1:High_Boost_Filter
	
	port map (
		CLK 	  => CLK,
		EN		  => EN,
		P_11 	  => P_11,
		P_12 	  => P_12,
		P_13 	  => P_13,
		P_21 	  => P_21,
		P_22 	  => P_22,
		P_23 	  => P_23,
		P_31 	  => P_31,
		P_32 	  => P_32,
		P_33 	  => P_33,
		PIXEL_OUT => PIXEL_OUT
		);
	
end Filter_Procedure_Arch;
